Index: trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 2542)
@@ -4,20 +4,27 @@
 !
 !     Author: Franck Lefevre
+!             Benjamin Charnay
+!             Yassin Jaziri
 !     ------
 !
-!     Version: 10/11/2015
+!     Version: 27/05/2016
+!     update 06/03/2021 generic tracer/network + photolysis online (Yassin Jaziri)
 !
 !*****************************************************************
 
-subroutine photochemistry_asis(nlayer, nq, ngrid,                               &
+subroutine photochemistry_asis(nlayer, ngrid,                                   &
                           ig, lswitch, zycol, sza, fractcol, ptimestep, press,  &
-                          temp, dens, zmmean, dist_sol, surfdust1d,             &
-                          surfice1d, jo3, tau, iter)
+                          alt, temp, dens, zmmean, dist_sol, surfdust1d,        &
+                          surfice1d, tau, iter,zdtchim)
 
       use callkeys_mod
+      use comcstfi_mod, only:  r,cpp,avocado,pi
+      use tracer_h
+      use types_asis
+      use chimiedata_h
+      use photolysis_mod
+
 implicit none
 
-#include "chimiedata.h" 
-
 !===================================================================
 !     inputs:
@@ -25,6 +32,6 @@
 
 integer, intent(in) :: nlayer ! number of atmospheric layers
-integer, intent(in) :: nq     ! number of tracers
-integer,intent(in) :: ngrid   ! number of atmospheric columns
+integer, intent(in) :: ngrid  ! number of atmospheric columns
+
 integer :: ig                 ! grid point index
       
@@ -33,4 +40,5 @@
 real :: ptimestep             ! physics timestep (s)
 real :: press(nlayer)         ! pressure (hpa)
+real :: alt(nlayer)           ! altitude (km)
 real :: temp(nlayer)          ! temperature (k)
 real :: dens(nlayer)          ! density (cm-3)
@@ -45,5 +53,5 @@
 !===================================================================
       
-real :: zycol(nlayer,nq)       ! chemical species volume mixing ratio
+real :: zycol(nlayer,nesp)    ! chemical species volume mixing ratio
 
 !===================================================================
@@ -51,6 +59,6 @@
 !===================================================================
       
-integer :: iter(nlayer)        ! iteration counter
-real    :: jo3(nlayer)         ! photodissociation rate o3 -> o1d
+integer :: iter(nlayer)       ! iteration counter
+real    :: zdtchim(nlayer)    ! temperature modification by ozone
 
 !===================================================================
@@ -59,31 +67,8 @@
 
 integer :: phychemrat         ! (physical timestep)/(nominal chemical timestep)
-integer :: j_o3_o1d, ilev
-integer :: iesp, nesp
+integer :: ilev, iesp, iphot, iw
 integer :: lswitch
 
 logical, save :: firstcall = .true.
-
-parameter (nesp = 17)         ! number of species in the chemistry
-
-! tracer indexes in the chemistry:
-
-integer,parameter :: i_co2  =  1
-integer,parameter :: i_co   =  2
-integer,parameter :: i_o    =  3
-integer,parameter :: i_o1d  =  4
-integer,parameter :: i_o2   =  5
-integer,parameter :: i_o3   =  6
-integer,parameter :: i_h    =  7
-integer,parameter :: i_h2   =  8
-integer,parameter :: i_oh   =  9
-integer,parameter :: i_ho2  = 10
-integer,parameter :: i_h2o2 = 11
-integer,parameter :: i_h2o  = 12
-integer,parameter :: i_n    = 13
-integer,parameter :: i_n2d  = 14
-integer,parameter :: i_no   = 15
-integer,parameter :: i_no2  = 16
-integer,parameter :: i_n2   = 17
 
 real :: stimestep           ! standard timestep for the chemistry (s) 
@@ -95,4 +80,5 @@
 real :: j(nlayer,nd)        ! interpolated photolysis rates (s-1)
 real :: time                ! internal time (between 0 and ptimestep, in s)
+real :: rho(nlayer)         ! mass density (kg/m-3)
 
 real, dimension(nlayer,nesp)            :: rm   ! mixing ratios 
@@ -103,22 +89,23 @@
 ! reaction rates
  
-real (kind = 8), dimension(nlayer,      nb_phot_max) :: v_phot
-real (kind = 8), dimension(nlayer,nb_reaction_3_max) :: v_3
-real (kind = 8), dimension(nlayer,nb_reaction_4_max) :: v_4
-logical :: hetero_dust, hetero_ice
+real (kind = 8), allocatable, save     :: v_phot(:,:)
+real (kind = 8), allocatable, save     :: v_3(:,:)
+real (kind = 8), allocatable, save     :: v_4(:,:)
+real (kind = 8), allocatable, save     :: e_phot(:,:)    ! photolysis rates by energie (J.mol-1.s-1)
+
+integer, save                          :: nreact         ! number of reactions in reactions files
+integer, allocatable, save             :: rtype(:)       ! reaction rate type
+integer, allocatable, save             :: third_body(:)  ! if the reaction have a third body: index of the third body, else zero
+logical, allocatable, save             :: three_prod(:)  ! if the reaction have a three defferent proucts egal .true.
 
 ! matrix
 
-real (kind = 8), dimension(nesp,nesp) :: mat, mat1
-integer, dimension(nesp)              :: indx
-integer                               :: code
+real (kind = 8), dimension(nesp,nesp)  :: mat, mat1
+integer, dimension(nesp)               :: indx
+integer                                :: code
 
 ! production and loss terms (for first-guess solution only)
 
-real (kind = 8), dimension(nesp) :: prod, loss
-
-! curvatures
-
-real :: ratio, curv, e, e1, e2, e3
+real (kind = 8), dimension(nesp)       :: prod, loss
 
 !===================================================================
@@ -128,7 +115,42 @@
 if (firstcall) then
    print*,'photochemistry: initialize indexes'
-   call indice(i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h,       &
-               i_h2, i_oh, i_ho2, i_h2o2, i_h2o,               &
-               i_n, i_n2d, i_no, i_no2, i_n2)
+   call indice(nreact,rtype,third_body,three_prod)
+   allocate(v_phot(nlayer,nb_phot_max))
+   allocate(v_3(nlayer,nb_reaction_3_max))
+   allocate(v_4(nlayer,nb_reaction_4_max))
+   allocate(v_phot_3d(ngrid,nlayer,nb_phot_hv_max))
+   allocate(e_phot(nlayer,nb_phot_max))
+   v_phot(:,:)      = 0.
+   v_3(:,:)         = 0.
+   v_4(:,:)         = 0.
+   v_phot_3d(:,:,:) = 0.
+   e_phot(:,:)      = 0.
+
+   ! Need to be done after subroutine indice
+   if (jonline) then
+     print*,'calchim: Read UV absorption cross-sections'
+     ! Jonline cannot run without photolysis
+     if (nb_phot_hv_max == 0) then
+       print*,'Jonline cannot run without photolysis'
+       print*,'set jonline=.false. in callphys.def'
+       print*,'or set photolysis reactions in monoreact file'
+       stop
+     end if
+     call init_photolysis(nlayer,nreact,three_prod)     ! on-line photolysis
+     allocate(albedo_snow_chim(nw))
+     allocate(albedo_co2_ice_chim(nw))
+    ! Step 1 : Initialisation of the Spectral Albedos.
+     DO iw=1,nw
+      albedo_snow_chim(iw)=albedosnow
+      albedo_co2_ice_chim(iw)=albedoco2ice
+
+      ! Spectral Snow Albedo Calculation.
+      call albedo_snow_calc(wc(iw)*1.0e-3,        &
+                     albedo_snow_chim(iw),  & 
+                     albedosnow)
+      
+     ENDDO
+   end if
+
    firstcall = .false.
 end if
@@ -138,8 +160,5 @@
 !===================================================================
 
-call gcmtochim(nlayer, nq, zycol, lswitch, nesp,               &
-               i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h,       &
-               i_h2, i_oh, i_ho2, i_h2o2, i_h2o,               &
-               i_n, i_n2d, i_no, i_no2, i_n2, dens, rm, c) 
+call gcmtochim(nlayer, zycol, lswitch, nesp, dens, rm, c) 
 
 !===================================================================
@@ -147,26 +166,71 @@
 !===================================================================
 
-call photolysis_asis(nlayer, ngrid, lswitch, press, temp, sza, fractcol, tau, zmmean, dist_sol, & 
-                     rm(:,i_co2), rm(:,i_o3), v_phot)
-
-! save o3 photolysis for output
-
-j_o3_o1d = 5
-jo3(:) = v_phot(:,j_o3_o1d)
+if (jonline) then
+   if (sza <= 95.) then
+      call photolysis_online(nlayer, alt, press, temp, zmmean, rm,   &
+                             tau, sza, dist_sol, v_phot, e_phot, ig, ngrid, nreact, three_prod)
+      if (ngrid.eq.1) then
+        do iphot = 1,nb_phot_hv_max
+          v_phot(:,iphot) = v_phot(:,iphot)* 0.25 / cos(sza*pi/180.) ! globally averaged = divide by 4
+          e_phot(:,iphot) = e_phot(:,iphot)* 0.25 / cos(sza*pi/180.) ! globally averaged = divide by 4
+        end do
+      elseif(diurnal .eqv. .false.) then
+        do iphot = 1,nb_phot_hv_max
+          v_phot(:,iphot) = v_phot(:,iphot) * fractcol
+          e_phot(:,iphot) = e_phot(:,iphot) * fractcol
+        end do
+      endif
+   else ! night
+      v_phot(:,:) = 0.
+      e_phot(:,:) = 0.
+   end if
+   ! save photolysis for output
+   v_phot_3d(ig,:,:) = v_phot(:,1:nb_phot_hv_max)
+else if (nb_phot_hv_max /= 0) then
+   call photolysis_asis(nlayer, ngrid, lswitch, press, temp, sza, fractcol,tau, zmmean, dist_sol, & 
+                     rm(:,indexchim('co2')), rm(:,indexchim('o3')), rm(:,indexchim('ch4')), v_phot)
+   ! save photolysis for output
+   v_phot_3d(ig,:,:) = v_phot(:,1:nb_phot_hv_max)
+end if
 
 !===================================================================
 !     reaction rates                                     
 !===================================================================
-!     switches for heterogeneous chemistry
-!     hetero_ice  : reactions on ice clouds
-!     hetero_dust : reactions on dust    
-!===================================================================
-
-hetero_dust = .false.
-hetero_ice  = .false.
-
-call reactionrates(nlayer, lswitch, dens, c(:,i_co2), c(:,i_o2), &
-                   press, temp, hetero_dust, hetero_ice,         &
-                   surfdust1d, surfice1d, v_phot, v_3, v_4)
+
+call reactionrates(nlayer, nreact, rtype, third_body, three_prod, c, lswitch, dens, &
+                   press, temp, zmmean, sza, surfdust1d, surfice1d, v_phot, v_3, v_4)
+
+zdtchim(:) = 0.
+rho(:)     = (press(:)*1e2)/(r*temp(:))
+
+!===================================================================
+!     temperature modification by photolysis reaction                                    
+!===================================================================
+
+if (photoheat .and. jonline) then ! for now just with jonline
+
+  do iphot = 1,nb_phot_hv_max
+    zdtchim(:nlayer-1) = zdtchim(:nlayer-1) + e_phot(:nlayer-1,iphot)*c(:nlayer-1,indexchim(trim(jlabel(iphot,2))))/(cpp*(rho(:nlayer-1)*1e-6)*avocado)
+  end do
+
+else
+
+!! o + o2 -> o3
+!!dE = 24 ! kcal.mol-1
+!!zdtchim(:) = zdtchim(:) + 4.184*24e3*v_4(:,1)*c(:,indexchim('o'))*c(:,indexchim('o2'))*1e6/(cpp*rho*avocado)
+!
+!! o3 -> o2 + o1d
+!! E(250nm) = 480 kJ.mol-1
+!j_o3_o1d   = 3
+!zdtchim(:) = zdtchim(:) + 480e3*v_phot(:,j_o3_o1d)*c(:,indexchim('o3'))/(cpp*(rho*1e-6)*avocado)
+!
+!! o3 -> o2 + o
+!! E(350nm) = 343 kJ.mol-1
+!j_o3_o     = 4
+!zdtchim(:) = zdtchim(:) + 343e3*v_phot(:,j_o3_o)*c(:,indexchim('o3'))/(cpp*(rho*1e-6)*avocado)
+
+zdtchim(:) = 0.
+
+end if
 
 !===================================================================
@@ -182,10 +246,4 @@
 
 ctimestep = ptimestep/real(phychemrat)
-
-!print*, "stimestep  = ", stimestep
-!print*, "ptimestep  = ", ptimestep
-!print*, "phychemrat = ", phychemrat
-!print*, "ctimestep  = ", ctimestep
-!stop
 
 !===================================================================
@@ -207,5 +265,5 @@
 
    iter(ilev) = iter(ilev) + 1    ! iteration counter
-
+  
 !  first-guess: fill matrix
 
@@ -268,8 +326,5 @@
 !===================================================================
 
-call chimtogcm(nlayer, nq, zycol, lswitch, nesp,              &
-               i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h,      &
-               i_h2, i_oh, i_ho2, i_h2o2, i_h2o,              &
-               i_n, i_n2d, i_no, i_no2, i_n2, dens, c) 
+call chimtogcm(nlayer, zycol, lswitch, nesp, dens, c) 
 
 contains
@@ -318,5 +373,5 @@
 real (kind = 8), parameter :: dtmin   = 10.      ! minimum time step (s)
 real (kind = 8), parameter :: vmrtol  = 1.e-11   ! absolute tolerance on vmr
-real (kind = 8), parameter :: rtol    = 1./0.05   ! 1/rtol recommended value : 0.1-0.02
+real (kind = 8), parameter :: rtol    = 1./0.05  ! 1/rtol recommended value : 0.1-0.02
 integer,         parameter :: niter   = 3        ! number of iterations
 real (kind = 8), parameter :: coefmax = 2.
@@ -382,5 +437,9 @@
 ! timestep correction
 
-coef = max(coefmin, min(coefmax,0.8/sqrt(e)))
+if (e <= 0.) then
+  coef = coefmax
+else
+  coef = max(coefmin, min(coefmax,0.8/sqrt(e)))
+end if
 
 dttest = max(dtmin,dttest*coef)
@@ -396,11 +455,8 @@
 
 
-
-
 !======================================================================
 
- subroutine reactionrates(nlayer,                               &
-                          lswitch, dens, co2, o2, press, t,     &
-                          hetero_dust, hetero_ice,              &
+ subroutine reactionrates(nlayer, nreact, rtype, third_body, three_prod, c, &
+                          lswitch, dens, press, t, zmmean, sza, &
                           surfdust1d, surfice1d,                &
                           v_phot, v_3, v_4)
@@ -418,8 +474,10 @@
 
 use comcstfi_mod
+use types_asis
+use pfunc
+use tracer_h
+use chimiedata_h
 
 implicit none
-
-#include "chimiedata.h"
 
 !----------------------------------------------------------------------
@@ -427,15 +485,20 @@
 !----------------------------------------------------------------------
 
-integer, intent(in)     :: nlayer            ! number of atmospheric layers
-integer                 :: lswitch           ! interface level between lower
-                                             ! atmosphere and thermosphere chemistries
-real, dimension(nlayer) :: dens              ! total number density (molecule.cm-3)
-real, dimension(nlayer) :: press             ! pressure (hPa)
-real, dimension(nlayer) :: t                 ! temperature (K)
-real, dimension(nlayer) :: surfdust1d        ! dust surface area (cm2.cm-3)
-real, dimension(nlayer) :: surfice1d         ! ice surface area (cm2.cm-3)
-real (kind = 8), dimension(nlayer) :: co2    ! co2 number density (molecule.cm-3)
-real (kind = 8), dimension(nlayer) :: o2     ! o2 number density (molecule.cm-3)
-logical :: hetero_dust, hetero_ice           ! switches for heterogeneous chemistry
+integer, intent(in)     :: nlayer             ! number of atmospheric layers
+integer, intent(in)     :: nreact             ! number of reactions in reactions files
+integer                 :: lswitch            ! interface level between lower
+                                              ! atmosphere and thermosphere chemistries
+real, dimension(nlayer) :: dens               ! total number density (molecule.cm-3)
+real, dimension(nlayer) :: press              ! pressure (hPa)
+real, dimension(nlayer) :: t                  ! temperature (K)
+real, dimension(nlayer) :: zmmean             ! mean molar mass (g/mole)
+real                    :: sza                ! solar zenith angle (deg)
+real, dimension(nlayer) :: surfdust1d         ! dust surface area (cm2.cm-3)
+real, dimension(nlayer) :: surfice1d          ! ice surface area (cm2.cm-3)
+real (kind = 8), dimension(nlayer,nesp) :: c  ! species number density (molecule.cm-3)
+
+integer, intent(in)     :: rtype(nreact)      ! reaction rate type
+integer, intent(in)     :: third_body(nreact) ! if the reaction have a third body: index of the third body, else zero
+logical, intent(in)     :: three_prod(nreact) ! if the reaction have three different products egal .true.
 
 !----------------------------------------------------------------------
@@ -451,19 +514,9 @@
 !----------------------------------------------------------------------
 
-integer          :: ilev
+logical,save     :: firstcall = .true.
+integer          :: ilev, ireact
 integer          :: nb_phot, nb_reaction_3, nb_reaction_4
-real :: ak0, ak1, xpo, rate
-real :: k1a0, k1b0, k1ainf, k1a, k1b, fc, fx, x, y, gam
-real, dimension(nlayer) :: deq
-real, dimension(nlayer) :: a001, a002, a003,                           &
-                             b001, b002, b003, b004, b005, b006, b007,   &
-                             b008, b009,                                 &
-                             c001, c002, c003, c004, c005, c006, c007,   &
-                             c008, c009, c010, c011, c012, c013, c014,   &
-                             c015, c016, c017, c018,                     &
-                             d001, d002, d003, d004, d005, d006, d007,   &
-                             d008, d009,                                 &
-                             e001, e002,                                 &
-                             h001, h002, h003, h004, h005
+integer          :: nb_hv, nb_pfunc1, nb_pfunc2, nb_pfunc3
+real, dimension(nlayer) :: ratec ! rate coefficient
 
 !----------------------------------------------------------------------
